#include <gint/display.h>
#include <gint/keyboard.h>
#include "main.h"

int collide(int x, int y, int level[16][16]) {
	if(!level[x / 12][y / 12]
		&& !level[(x + 12) / 12][y / 12]
		&& !level[x / 12][(y + 12) / 12]
		&& !level[(x + 12) / 12][(y + 12) / 12]) {
		return 0;
	}
	return 1;
}

int main(void)
{
	extern bopti_image_t img_player;
	extern bopti_image_t img_wall;

	extern int level[16][16];

	int running = 1;

	// player (i don't know how to use struct sorry)
	int player_x = 50;
	int player_y = 50;

	// main loop
	while(running) {

		dclear(C_BLACK);

		// drawing the player
		dimage(player_x, player_y, &img_player);

		// drawing the level
		for(int m = 0; m < 16; ++m){
			for(int n = 0; n < 16; ++n){
				if(level[m][n]) {
					dimage(m * 12, n * 12, &img_wall);
				}
			}
		}

		dupdate();
		int mov_x = keydown(KEY_RIGHT) - keydown(KEY_LEFT);
		int mov_y = keydown(KEY_DOWN) - keydown(KEY_UP);
		clearevents();

		// trying to move the player >w<
		if(!collide(player_x + mov_x, player_y, level)) {
			player_x += mov_x;
		}

		if(!collide(player_x, player_y + mov_y, level)) {
			player_y += mov_y;
		}
		
		if(keydown(KEY_EXIT)) {running = 0;}
	}

	return 1;
}
